#pragma once

#include "Model3D.h"

namespace Framework
{
    class Textur;

    // Ein 3D Modell, das zur Darstellung einer Textur im dreidimensionalen Raum verwendet werden kann
    class TexturModel : public Model3D
    {
    public:
        // Konstruktor
        __declspec( dllexport ) TexturModel();
        // Setzt die Textur die angezeigt werden soll 
        //  t: Die Textur
        __declspec( dllexport ) void setTextur( Textur *t );
        // Setzt die Gre, in der Die Textur angezeigt wird
        //  gr: Ein Vektor, der fr x und y die breite und hhe beinhaltet
        __declspec( dllexport ) void setSize( Vec2< float > gr );
        // Setzt die Gre, in der die Textur angezeigt wird
        //  b: Die Breite, in der die Textur angezeigt wird
        //  h: Die Hhe, in der die Textur angezeigt wird
        __declspec( dllexport ) void setSize( float b, float h );
    };
}